///////////////////////////////////////////////////
//                        //
///////////////////////////////////////////////////

#ifndef O2M_H_FILE_FileIO
#define O2M_H_FILE_FileIO

#include <stdio.h>

namespace FileIO {

    // -  
    const int ResetError = 1;
    const int RewriteError = 2;
    const int CloseError = 3;
    const int AlreadyOpened = 4;
    const int AlreadyClosed = 5;
    const int NotOpenedForWriting = 6;

    //  
    struct TFile {
        //    id   
        virtual const char* O2M_SYS_ID() {return "TFile@FileIO";};
        FILE *O2M_M_f;          //FILE *stream
        char *O2M_M_FName;      // 
        int O2M_M_IORes;        //    
        char O2M_M_OpenState;   //'w' - , 'r' - , 'n' - 
        //  
        TFile() : O2M_M_f(NULL), O2M_M_FName(NULL), O2M_M_IORes(0), O2M_M_OpenState('n') {};
        ~TFile();
        //        
        virtual int IOResult();
        //    
        virtual void Assign(const char *FileName, const int FileNameSize);
        //   
        virtual void Reset();
        //   
        virtual void Rewrite();
        //    
        virtual int Write(char *Block, const int BlockSize);
        //         
        virtual int Writeln(char *Block, const int BlockSize);
        //    
        virtual int Read(char *Block, const int BlockSize);
        //  
        virtual bool Eof();
        //  
        virtual void Close();
          
        // ,       -  In     

        //      
        int ReadChar(char &ch);
        int ReadInt(int &i);
        int ReadLongInt(long &i);
        int ReadReal(double &x);
        int ReadLongReal(long double &y);
        int ReadName(char nme[]);
        int ReadString(char *str, int str_len);         
        
        // ,       -  Out
        
        int WriteChar(char ch);
        int WriteString(char str[]);
        int WriteString(char *str, int O2M_ARR_0_str);
        int WriteInt(long x,long n);
        int WriteReal(double x, long n);
        int WriteLongReal(long double x, long n);
        int Ln();


    };

    //   FileIO
    void O2M_SYS_FileIO();

}//namespace FileIO

#endif
