////////////////////////////////////////////////////////
//  ,    ()  //
////////////////////////////////////////////////////////

#include "SysUtils.h"
#include <stdlib.h>

const int INC_RAND_MAX = RAND_MAX + 1;


//-----------------------------------------------------------------------------
//    
SysUtils::TDateTime SysUtils::Now() {
	TDateTime dtm;
	return time(&dtm);
}


//-----------------------------------------------------------------------------
//      
// S      26 
void SysUtils::DateTimeToStr(SysUtils::TDateTime DateTime, char *S, const int O2M_ARR_0_S) {
	if (26 > O2M_ARR_0_S) return;
	const char* st = ctime(&DateTime);
	for (int i = 0; i < 26; i++) S[i] = st[i];
}


//-----------------------------------------------------------------------------
// TDateTime  , , , , , 
void SysUtils::DecodeDateTime(SysUtils::TDateTime DateTime, int &Year, int &Mon, int &Day, int &Hour, int &Min, int &Sec) {
	tm* ptm = localtime(&DateTime);
	Year = ptm->tm_year + 1900;
	Mon = ptm->tm_mon + 1;
	Day = ptm->tm_mday;
	Hour = ptm->tm_hour;
	Min = ptm->tm_min;
	Sec = ptm->tm_sec;
}


//-----------------------------------------------------------------------------
// TDateTime     
void SysUtils::DecodeDateTimeEx(SysUtils::TDateTime DateTime, SysUtils::TDTRec* DTRec) {
	tm* ptm = localtime(&DateTime);
	DTRec->YDay = ptm->tm_yday;
	DTRec->WDay = ptm->tm_wday;
	DTRec->Year = ptm->tm_year + 1900;
	DTRec->Mon = ptm->tm_mon + 1;
	DTRec->Day = ptm->tm_mday;
	DTRec->Hour = ptm->tm_hour;
	DTRec->Min = ptm->tm_min;
	DTRec->Sec = ptm->tm_sec;
}


//-----------------------------------------------------------------------------
//     
int SysUtils::DayOfWeek(SysUtils::TDateTime DateTime) {
	return localtime(&DateTime)->tm_wday;
}


//-----------------------------------------------------------------------------
//     0 <= X < 1
double SysUtils::Rand() {
	return (double)rand() / INC_RAND_MAX;
}


//-----------------------------------------------------------------------------
//     0 <= X < Range
int SysUtils::Random(const int Range) {
	return rand() * Range / INC_RAND_MAX;
}


//-----------------------------------------------------------------------------
//     
void SysUtils::Randomize() {
	srand((unsigned)time(NULL));
}


//-----------------------------------------------------------------------------
//   
void SysUtils::RandSeed() {
	srand(1);
}


//-----------------------------------------------------------------------------
//  
void SysUtils::O2M_SYS_SysUtils()
{}
