///////////////////////////////////////////////////
//       //
//     Windows            //
///////////////////////////////////////////////////

#include <windows.h>
#include "Resource.h"

#include "Win.h"


// Application name and instance storeage
static LPCTSTR lpszAppName = "O2M Window";
static HINSTANCE hInstance;


//    
BOOL APIENTRY AboutDlgProc(HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	
	switch (message) {
		//Initialize the dialog box
		case WM_INITDIALOG:
			break;

		//Process command messages
		case WM_COMMAND:
			//     OK
			if(LOWORD(wParam) == IDOK) EndDialog(hDlg,TRUE);
			break;

		//Closed from sysbox
		case WM_CLOSE:
			EndDialog(hDlg,TRUE);
			break;
	}//switch

	return FALSE;
}


// 
LONG WINAPI WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {

		//  
		case WM_DESTROY:
			PostQuitMessage(0);
			break;

		//A menu command
		case WM_COMMAND:
			{
			switch(LOWORD(wParam))
				{
				//Exit the program
				case ID_FILE_EXIT:
					PostMessage(hWnd, WM_CLOSE, 0, 0);
					break;

				//Display the about box
				case ID_HELP_ABOUT:
					DialogBox (hInstance,
						MAKEINTRESOURCE(IDD_DIALOG_ABOUT),
						hWnd,
						AboutDlgProc);
					break;
				}
			}
			break;
	}//switch

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}


//   
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPreviousInst,
	LPSTR lpCmdLine, int nCmdShow)
{
	//    
	O2M_SYS_main_init();


	MSG			msg;		// Windows message structure
	WNDCLASS	wc;			// Windows class structure
	HWND		hWnd;		// Storage for window handle

	hInstance = hInst;

	//Register Window style
	wc.style		= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc	= (WNDPROC) WindowProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= hInstance;
	wc.hIcon		= NULL;
	wc.hCursor		= LoadCursor(NULL, IDC_ARROW);
	
	// 
	wc.hbrBackground	= (HBRUSH)COLOR_WINDOW;
	
	wc.lpszMenuName		= MAKEINTRESOURCE(IDR_MAIN_MENU);
	wc.lpszClassName	= lpszAppName;

	//Register the window class
	if(RegisterClass(&wc) == 0) return FALSE;

	//Create the main application window
	hWnd = CreateWindow(
				lpszAppName,
				lpszAppName,

				//OpenGL requires WS_CLIPCHILDREN and WS_CLIPSIBLINGS
				WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_CLIPSIBLINGS,

				//Window position and size
				50, 50,
				400, 400,
				NULL,
				NULL,
				hInstance,
				NULL);

	//If window was not created, quit
	if(hWnd == NULL) return FALSE;

	//Display the window
	ShowWindow(hWnd,SW_SHOW);
	UpdateWindow(hWnd);

	//Process application messages until the application closes
	while( GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// 
	DestroyWindow(hWnd);
	
	return msg.wParam;
}


//   Windows
void Win::O2M_SYS_Win()
{}