//////////////////////////////////////////
//      Windows //
//////////////////////////////////////////

#ifndef O2M_H_FILE_WinConsole
#define O2M_H_FILE_WinConsole

#include <windows.h>

namespace WinConsole {

const short Black			= 0;	//0
const short Blue			= 1;	//FOREGROUND_BLUE
const short Green			= 2;
const short Cyan			= 3;
const short Red				= 4;
const short Magenta			= 5;
const short Brown			= 6;
const short LightGray		= 7;
const short DarkGray		= 8;
const short LightBlue		= 9;	//FOREGROUND_BLUE | FOREGROUND_INTENSITY
const short LightGreen		= 10;
const short LightCyan		= 11;
const short LightRed		= 12;
const short LightMagenta	= 13;
const short Yellow			= 14;
const short White			= 15;	//FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE | FOREGROUND_INTENSITY

// ,     
typedef short TColor;

//      
struct TScreenBuffer {
	virtual const char* O2M_SYS_ID() {return "TScreenBuffer@WinConsole";};
	//  
	HANDLE O2M_M_Handle;
	//      
	bool Error;
	//     
	TScreenBuffer();
	//   ,   STD_OUTPUT_BUFFER
	TScreenBuffer(bool O2M_FAKE_PARAMETER);
	//     (  )
	virtual void SetActive();
	//  
	virtual void SetCursorPos(const short X, const short Y);
	// Count    ,     ,
	// - -   )
	virtual int Write(const char *S, const int SSize, const int Count);
	//     ,     
	// - -   )
	virtual void WriteStr(const char *S, const int SSize);
	// Count      ,
	// -    
	virtual int ReadScreen (char *S, const int SSize, const short X, const short Y, const int Count);
	//    
	virtual void SetTextAttr(const short TextColor, const short BackgroundColor);
	//       ,
	// -      
	virtual int FillAttr (const short TextColor, const short BackgroundColor, const short X, const short Y, const int Count);
	//  
	virtual void GetCursorPos(short &X, short &Y);
};

//    
extern TScreenBuffer StdOutput;

//  ,     Windows
int GetWinTickCount();

// Count        ,
// -    
int Read (char *S, const int SSize, const int Count);

//        
// 0     (,  )
char ReadChar();

//         
// 0     (,  )
//KeyDown   TRUE   ,  FALSE  
char ReadCharEx(bool &KeyDown);

//          
// 0     (,  )
short ReadKey();

//           
// 0     (,  )
//KeyDown   TRUE   ,  FALSE  
short ReadKeyEx(bool &KeyDown);

//  
void FlushInputBuffer();

//  ,
//EditStyleInput:
//  TRUE  -      ,  -  Enter
//  FALSE -         
//ProcessedInput:
//  TRUE  -   (Ctrl+C  ..)     
//  FALSE -   ( .. Ctrl+C  ..)    
//    SetInputMode(FALSE, TRUE)
void SetInputMode(const bool EditStyleInput, const bool ProcessedInput);

//      -
// / ,    ..
bool InputBufferEmpty();

//  
void SetTitle(const char *Title, const int TitleSize);

//   WinConsole
void O2M_SYS_WinConsole();

}//namespace WinConsole

#endif
