//////////////////////////////////////////////////
//       Win32 GDI //
//////////////////////////////////////////////////

#ifndef O2M_H_FILE_WinGraph
#define O2M_H_FILE_WinGraph

namespace WinGraph {

//////////////////////////////////////////////////
// ,    WinGraph

//   
typedef int TColor;
//  
typedef int TFillStyle;
//  
typedef int TPenStyle;
//   c   
typedef int TBkMode;
//  
typedef int TBrushStyle;

//////////////////////////////////////////////////
//,    WinGraph

// 
const TColor clAqua			= 0x00FFFF00;	//-
const TColor clBlack		= 0x00000000;	//
const TColor clBlue			= 0x00FF0000;	//
const TColor clFuchsia		= 0x00FF00FF;	//
const TColor clGray			= 0x00808080;	// ( DkGray  Delphi)
const TColor clGreen		= 0x00008000;	//
const TColor clLime			= 0x0000FF00;	//
const TColor clMaroon		= 0x00000080;	//-
const TColor clNavy			= 0x00800000;	//-
const TColor clOlive		= 0x00008080;	//
const TColor clPurple		= 0x00800080;	//
const TColor clRed			= 0x000000FF;	//
const TColor clSilver		= 0x00C0C0C0;	// ( LtGray  Delphi)
const TColor clTeal			= 0x00808000;	//teal
const TColor clWhite		= 0x00FFFFFF;	//
const TColor clYellow		= 0x0000FFFF;	//
// 
extern const TFillStyle fsBorder;			// ,   
extern const TFillStyle fsSurface;			// ,   
// 
extern const TPenStyle psSolid;				// 
extern const TPenStyle psDash;				// 
extern const TPenStyle psDot;				//  
extern const TPenStyle psDashDot;			//    
extern const TPenStyle psDashDotDot;		//     
extern const TPenStyle psClear;				// 
//     
extern const TBkMode bkOpaque;				//   
extern const TBkMode bkTransparent;			//  
// 
const TBrushStyle bsSolid		= 0;		//,  
const TBrushStyle bsClear		= 1;		// 
const TBrushStyle bsBDiagonal	= 2;		//    , 45  ( )
const TBrushStyle bsCross		= 3;		//
const TBrushStyle bsDiagCross	= 4;		// 
const TBrushStyle bsFDiagonal	= 5;		//    , 45  ( )
const TBrushStyle bsHorizontal	= 6;		// 
const TBrushStyle bsVertical	= 7;		// 


//////////////////////////////////////////////////
//    

// ,    
void Arc (int LeftRect, int TopRect, int RightRect, int BottomRect, int XStartArc, int YStartArc, int XEndArc, int YEndArc);
//      
void Clear ();
//     
void Ellipse (int LeftRect, int TopRect, int RightRect, int BottomRect);
//  ,    
void FloodFill (int x, int y, TColor Color, TFillStyle FillStyle);
//    (x1, y1)  (x2, y2)
void Line (int x1, int y1, int x2, int y2);
//       
void LineTo (int x, int y);
//     
void MoveTo (int x, int y);
//      
void OutString (int x, int y, char *O2M_ARR_String, const int O2M_ARR_0_String);
//       
void OutText (int x, int y, char *O2M_ARR_Text, const int O2M_ARR_0_Text, int CharCount);
// ,    
void Pie (int LeftRect, int TopRect, int RightRect, int BottomRect, int XRadial1, int YRadial1, int XRadial2, int YRadial2);
//      
void PieSlice (int x, int y, int Radius, double StartAngle, double SweepAngle);
//   
void Rectangle (int LeftRect, int TopRect, int RightRect, int BottomRect);
//   
void RoundRect (int LeftRect, int TopRect, int RightRect, int BottomRect, int WidthEllipse, int HeightEllipse);
//   
void SetBkColor (TColor Color);
//       
void SetBkMode (TBkMode Mode);
//   
void SetBrushColor (TColor Color);
//   
void SetBrushStyle (TBrushStyle BrushStyle);
//   
void SetPenColor (TColor Color);
//   
void SetPenStyle (TPenStyle Style);
//       
void SetPixel (int x, int y, TColor Color);
//   
void SetTextColor (TColor Color);
//   
int TextHeight (char *O2M_ARR_Text, const int O2M_ARR_0_Text, int CharCount);
//   
int TextWidth (char *O2M_ARR_Text, const int O2M_ARR_0_Text, int CharCount);

//////////////////////////////////////////////////
//   WinGraph
void O2M_SYS_WinGraph();

}//namespace WinGraph

#endif
